package dataExchange;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 * Ramka z menu, ktrego akcja Plik/Pocz wywietla okno dialogowe z polem hasa.
 */
public class DataExchangeFrame extends JFrame
{
   public static final int TEXT_ROWS = 20;
   public static final int TEXT_COLUMNS = 40;
   private PasswordChooser dialog = null;
   private JTextArea textArea;

   public DataExchangeFrame()
   {
      // Tworzenie menu Plik

      var mbar = new JMenuBar();
      setJMenuBar(mbar);
      var fileMenu = new JMenu("Plik");
      mbar.add(fileMenu);

      // Tworzenie elementw menu Pocz i Zamknij

      var connectItem = new JMenuItem("Pocz");
      connectItem.addActionListener(new ConnectAction());
      fileMenu.add(connectItem);

      // Opcja Zamknij zamyka program

      var exitItem = new JMenuItem("Zamknij");
      exitItem.addActionListener(event -> System.exit(0));
      fileMenu.add(exitItem);

      textArea = new JTextArea(TEXT_ROWS, TEXT_COLUMNS);
      add(new JScrollPane(textArea), BorderLayout.CENTER);
      pack();
   }

   /**
    * Akcja Connect wywietla okno dialogowe z polem hasa
    */
   private class ConnectAction implements ActionListener
   {
      public void actionPerformed(ActionEvent event)
      {
         // Jeli jest to pierwszy raz, tworzy okno dialogowe

         if (dialog == null) dialog = new PasswordChooser();

         // Ustawianie wartoci domylnych
         dialog.setUser(new User("Twoja nazwa", null));

         // Wywietlenie okna dialogowego
         if (dialog.showDialog(DataExchangeFrame.this, "Connect"))
         {
            // Pobranie danych uytkownika w przypadku zatwierdzenia
            User u = dialog.getUser();
            textArea.append("Nazwa uytkownika = " + u.getName() + ", haso = "
                  + (new String(u.getPassword())) + "\n");
         }
      }
   }
}